{

avail maker for fastecho and other
(c) 2001 by raVen

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit feAvail;
interface
Uses Objects, rObjects;
{}
type
{( tAvailList )}
 pAvailList = ^tAvailList;
 tAvailList = object(tObject)
  LinkAddr,FileName: pString;
  constructor Init(const aLinkAddr,aFileName: String);
  destructor Done; virtual;
  function SaveAvailList(aFileName: String): Byte;
  procedure FreeAvailList;
  function LoadEchoList(const aFileName: String): Byte;
  procedure FreeEchoList;
  procedure AddArea(aAreaName,aAreaDesc: String);
  function GetAreaCount: Integer;
 private
  EchoListAreas,EchoListDescs,AreaNames,AreaDescs: pStringCollection;
 end;
{( tAvailListCollection )}
 pAvailListCollection = ^tAvailListCollection;
 tAvailListCollection = object(tSortedCollection)
  constructor Init;
  destructor Done; virtual;
  function Compare(Key1,Key2: Pointer): Integer; virtual;
  function LoadEchoList(const aFileName: String): Byte;
  function EchoListEmpty: Boolean;
  procedure AddArea(aLinkAddr,aAreaName,aAreaDesc: String);
 private
  EchoListAreas,EchoListDescs: pStringCollection;
 end;
{}
implementation
Uses rCommon, rStrings, rFido;
{( tAvailList )}
constructor tAvailList.Init;
 begin
  inherited Init;
  New(EchoListAreas,Init(16,16));
  New(EchoListDescs,Init(16,16));
  New(AreaNames,Init(16,16));
  New(AreaDescs,Init(16,16));
  LinkAddr:=nil;
  FileName:=nil;
  ReallocStr(LinkAddr,TruncateAddr(aLinkAddr));
  ReallocStr(FileName,aFileName);
 end;
{}
destructor tAvailList.Done;
 begin
  DisposeObj(EchoListAreas);
  DisposeObj(EchoListDescs);
  DisposeObj(AreaNames);
  DisposeObj(AreaDescs);
  ReallocStr(LinkAddr,'');
  ReallocStr(FileName,'');
  inherited Done;
 end;
{}
function tAvailList.SaveAvailList;
 var
  Link: pStream;
  x: Integer;
  s: String;
 begin
  if (AreaNames^.Count<=0) then exit;
  if (aFileName='') then aFileName:=GetPS(FileName);
  MkTree(aFileName);
  ZeroFile(aFileName);
  Link:=New(pBufStream,Init(aFileName,stIntOpen or fmWrite or fmDenyWrite,BlockSize));
  with (AreaNames^) do for x:=0 to Count-1 do
   begin
    if (AreaDescs^.At(x)<>nil) then s:=Pad(GetPS(At(x)),29)+Space+Quote1+GetPS(AreaDescs^.At(x))+Quote1
    else s:=GetPS(At(x));
    StreamWriteLn(Link^,s,cr+lf);
   end;
  DisposeObj(Link);
 end;
{}
procedure tAvailList.FreeAvailList;
 begin
  AreaNames^.FreeAll;
  AreaDescs^.FreeAll;
 end;
{}
function tAvailList.LoadEchoList;
 var
  f: Text;
  oldfm: Byte;
  s: String;
  ps: pString;
  z,i: Integer;
 begin
  oldfm:=FileMode;
  FileMode:=fmRead or fmDenyNone;
  assign(f,aFileName);
  Reset(f);
  FileMode:=oldfm;
  while (not Eof(f)) do
   begin
    ReadLn(f,s);
    if (s[1]=';') or (s='') then continue;
    ps:=nil;
    z:=Integer(not (s[1]=','));
    ReallocStr(ps,UpStr(ExtractWord(1+z,s,[Comma])));
    if (not EchoListAreas^.Search(ps,i)) then
     begin
      EchoListAreas^.Insert(ps);
      EchoListDescs^.AtInsert(EchoListAreas^.IndexOf(ps),NewStr(ExtractWord(2+z,s,[Comma])));
     end
    else ReallocStr(ps,'');
   end;
  Close(f);
 end;
{}
procedure tAvailList.FreeEchoList;
 begin
  EchoListAreas^.FreeAll;
  EchoListDescs^.FreeAll;
 end;
{}
procedure tAvailList.AddArea;
 var
  i: Integer;
  ps: pString;
 begin
  ps:=nil;
  if (aAreaName='') then exit;
  aAreaName:=UpStr(aAreaName);
  if (aAreaDesc='') then if (EchoListAreas^.Search(@aAreaName,i)) then aAreaDesc:=GetPS(EchoListDescs^.At(i));
  ReallocStr(ps,aAreaName);
  if (not AreaNames^.Search(ps,i)) then
   begin
    AreaNames^.Insert(ps);
    AreaDescs^.AtInsert(AreaNames^.IndexOf(ps),NewStr(aAreaDesc));
   end
  else ReallocStr(ps,'');
 end;
{}
function tAvailList.GetAreaCount;
 begin
  GetAreaCount:=AreaNames^.Count;
 end;
{( tAvailListCollection )}
constructor tAvailListCollection.Init;
 begin
  inherited Init(16,16);
  New(EchoListAreas,Init(16,16));
  New(EchoListDescs,Init(16,16));
 end;
{}
destructor tAvailListCollection.Done;
 begin
  DisposeObj(EchoListAreas);
  DisposeObj(EchoListDescs);
  inherited Done;
 end;
{}
function tAvailListCollection.Compare;
 var
  s1,s2: String;
 begin
  s1:=GetPS(pAvailList(Key1)^.LinkAddr);
  s2:=GetPS(pAvailList(Key2)^.LinkAddr);
  if (s1>s2) then Compare:=-1
  else if (s1<s2) then Compare:=1
  else Compare:=0;
 end;
{}
function tAvailListCollection.LoadEchoList;
 var
  f: Text;
  oldfm: Byte;
  s: String;
  ps: pString;
  z,i: Integer;
 begin
{  EchoListAreas^.FreeAll;
  EchoListDescs^.FreeAll;}
  oldfm:=FileMode;
  FileMode:=fmRead or fmDenyNone;
  assign(f,aFileName);
  Reset(f);
  FileMode:=oldfm;
  while (not Eof(f)) do
   begin
    ReadLn(f,s);
    if (s[1]=';') or (s='') then continue;
    ps:=nil;
    z:=Integer(not (s[1]=','));
    ReallocStr(ps,UpStr(ExtractWord(1+z,s,[Comma])));
    if (not EchoListAreas^.Search(ps,i)) then
     begin
      EchoListAreas^.Insert(ps);
      EchoListDescs^.AtInsert(EchoListAreas^.IndexOf(ps),NewStr(ExtractWord(2+z,s,[Comma])));
     end
    else ReallocStr(ps,'');
   end;
  Close(f);
 end;
{}
function tAvailListCollection.EchoListEmpty;
 begin
  EchoListEmpty:=EchoListAreas^.Count=0;
 end;
{}
procedure tAvailListCollection.AddArea;
 var
  al: pAvailList;
  i: Integer;
 begin
  if ((aLinkAddr='') or (aAreaName='')) then exit;
  New(al,Init(aLinkAddr,''));
  if (Search(al,i)) then
   begin
    DisposeObj(al);
    al:=At(i);
   end
  else Insert(al);
  aAreaName:=UpStr(aAreaName);
  if (aAreaDesc='') then if (EchoListAreas^.Search(@aAreaName,i)) then aAreaDesc:=GetPS(EchoListDescs^.At(i));
  al^.AddArea(aAreaName,aAreaDesc);
 end;
{}
end.
