{.$Define Debug}

{&Use32+}
Uses
 rError, Objects, rMacroz, rObjects, Drivers, rStrings, Strings, rCommon,
 rConfig, feavail, OpCrt, rAbs, Dos, rOpen, rFido, RegExp;

const
 AppName: pChar = 'raVen''s avail manager';
 ShortAppName: pChar = 'RAMa';
 AppVer: pChar = '0.1';
 LongAppVer: pChar = '0.1.666';

 cfgYes: pChar = 'Yes';
 cfgNo: pChar = 'No';
 cfgValid: pChar = 'Valid';

 cmdScan: pChar = '/scan';
 cmdAsk: pChar = '/ask';

procedure ErrorExit;
 begin
  if (ErrorAddr<>nil) then
   begin
    WriteLn(cr+lf+'oops! i did it again...'+cr+lf+'see error log ['+ForceExtension(ParamStr(0),'rte')+']...');
   end;
 end;

type
 tKillScannedMsg = (ksmYes,ksmNo,ksmValid);

 tRAMa = object(tObject)
  constructor Init;
  destructor Done; virtual;
  procedure Run;
  procedure Abort(ExitCode: Byte);
  function ReadConfig(const FileName: String): Byte;
  procedure DoScan;
  procedure DoAsk;
 private
  Aborted,
  ErrorExit,
  EchoListLoaded: Boolean;
  MainAddr,
  MainName,
  ScanArea,
  NetMailArea,
  NetMailFlag: pString;
  FromName, FromAddr,
  ToName, ToAddr,
  EchoList: pStringCollection;
  masSubject, masRegExp, masCatch,
  alFromAddr, alPassword, alListName, alMsgText: pStrLines;
  KillScannedMsg: tKillScannedMsg;
  lists: pAvailListCollection;

end;

constructor tRAMa.Init;
 begin
  FixFucked;
  inherited Init;
  Aborted:=False;
  ErrorExit:=False;
  EchoListLoaded:=False;
  ScanArea:=nil;
  NetMailArea:=nil;
  NetMailFlag:=nil;
  MainAddr:=nil;
  MainName:=nil;
  New(FromName,Init(16,16));
  New(FromAddr,Init(16,16));
  New(ToName,Init(16,16));
  New(ToAddr,Init(16,16));
  New(EchoList,Init(16,16));
  New(masSubject,Init(16,16));
  New(masRegExp,Init(16,16));
  New(masCatch,Init(16,16));
  New(alFromAddr,Init(16,16));
  New(alPassword,Init(16,16));
  New(alListName,Init(16,16));
  New(alMsgText,Init(16,16));
  New(Lists,Init);
 end;

destructor tRAMa.Done;

 procedure SaveList(Item: Pointer);
  begin
   with (pAvailList(Item)^) do if (GetAreaCount>0) then
    begin
     PrintStr('saving list ['+GetPS(pAvailList(Item)^.FileName)+']... ');
     SaveAvailList('');
     PrintStr('gotcha!'+cr+lf);
    end;
  end;

 begin
  if (not Aborted) then lists^.ForEach(@SaveList);

  ReallocStr(MainAddr,'');
  ReallocStr(MainName,'');
  ReallocStr(ScanArea,'');
  ReallocStr(NetMailArea,'');
  ReallocStr(NetMailFlag,'');
  DisposeObj(FromName);
  DisposeObj(FromAddr);
  DisposeObj(ToName);
  DisposeObj(ToAddr);
  DisposeObj(EchoList);
  DisposeObj(masSubject);
  DisposeObj(masRegExp);
  DisposeObj(masCatch);
  DisposeObj(alPassword);
  DisposeObj(alFromAddr);
  DisposeObj(alListName);
  DisposeObj(alMsgText);
  DisposeObj(Lists);

  inherited Done;
  PrintFucked;
 end;

procedure tRAMa.Abort;
 begin
  Aborted:=True;
  ErrorExit:=ExitCode<>0;
  PrintStr('... aborted!'+cr+lf);
  Done;
  Halt(ExitCode);
 end;

procedure tRAMa.Run;
 var
  s: String;
  i: Integer;
  AreaNr,time: Longint;
  m: pMacros;
 begin
  PrintStr(+cr+lf+''+StrPas(AppName)+' v'+StrPas(AppVer)+cr+lf);
  PrintStr('(q) 2k1 by raVen'+cr+lf);

  if (ParamCount<1) then
   begin
    PrintStr('usage: rama.exe [switch] [switch] [switch] ...'+cr+lf);
    PrintStr('/scan - scan netmail for uplink''s areafix avail messages;'+cr+lf);
    PrintStr('/ask  - ask avail list of uplinks for scan and process it;'+cr+lf);
    Abort(1);
   end;

  s:='RAMa.ctl';
  if (not Exist(s)) then s:=AddBackSlash(JustPathName(ParamStr(0)))+s;
  if (not Exist(s)) then
   begin
    PrintStr('configuration file ['+s+'] is NOT found');
    Abort(255);
   end;
  PrintStr('loading config file...');
  if (ReadConfig(s)<>0) then
   begin
    PrintStr(' cannot read config ['+s+']');
    Abort(255);
   end;
  PrintStr(' done!'+cr+lf);

  i:=1;
  while (i<=ParamCount) do
   begin
    s:=UpStr(ParamStr(i));
    if (s=UpStr(StrPas(cmdScan))) then DoScan
    else if (s=UpStr(StrPas(cmdAsk))) then DoAsk
    else
     begin
      PrintStr('invalid switch ['+ParamStr(i)+'] in command line. check hands!'+cr+lf);
      Abort(200);
     end;
    Inc(i);
   end;
 end;

function tRAMa.ReadConfig;
 const
  Separators: set of char = [''];
 var
  cfg: pTextConfig;
  s: String;
  ps: pString;
  l,x,i: Integer;
 begin
  ReadConfig:=1;
  New(cfg,Init);

  with (cfg^) do
   begin
{00}AddWord('ScanArea');
{01}AddWord('KillScannedMsg');
{02}AddWord('FromName');
{03}AddWord('FromAddr');
{04}AddWord('ToName');
{05}AddWord('ToAddr');
{06}AddWord('MatchAvailStr');
{07}AddWord('EchoList');
{08}AddWord('AvailList');
{09}AddWord('NetMailFlag');
{10}AddWord('NetMailArea');

    if (LoadWB(FileName)<>0) then
     begin
      DisposeObj(cfg);
      exit;
     end;

    ReallocStr(ScanArea,Trim(GetValue(0,0),SpaceChars));

    s:=UpStr(GetValue(1,0));
    if (s=UpStr(StrPas(cfgYes))) then KillScannedMsg:=ksmYes
    else if (s=UpStr(StrPas(cfgValid))) then KillScannedMsg:=ksmValid
    else KillScannedMsg:=ksmNo;

    l:=GetValueCount(2);
    ps:=nil;
    if (l>0) then for x:=0 to l-1 do
     begin
      ReallocStr(ps,UpStr(GetValue(2,x)));
      with (FromName^) do if (not Search(ps,i)) then
       begin
        Insert(ps);
        ps:=nil;
       end;
     end;

    l:=GetValueCount(3);
    ps:=nil;
    if (l>0) then for x:=0 to l-1 do
     begin
      ReallocStr(ps,UpStr(GetValue(3,x)));
      with (FromAddr^) do if (not Search(ps,i)) then
       begin
        Insert(ps);
        ps:=nil;
       end;
     end;

    l:=GetValueCount(4);
    ps:=nil;
    if (l>0) then for x:=0 to l-1 do
     begin
      if (x=0) then ReallocStr(MainName,GetValue(4,x));
      ReallocStr(ps,UpStr(GetValue(4,x)));
      with (ToName^) do if (not Search(ps,i)) then
       begin
        Insert(ps);
        ps:=nil;
       end;
     end;

    l:=GetValueCount(5);
    ps:=nil;
    if (l>0) then for x:=0 to l-1 do
     begin
      if (x=0) then ReallocStr(MainAddr,GetValue(5,x));
      ReallocStr(ps,UpStr(GetValue(5,x)));
      with (ToAddr^) do if (not Search(ps,i)) then
       begin
        Insert(ps);
        ps:=nil;
       end;
     end;

    l:=GetValueCount(6);
    if (l>0) then for x:=0 to l-1 do
     begin
      masSubject^.Insert(NewStr(UpStr(Trim(Trim(ExtractWord(1,GetValue(6,x),Separators),SpaceChars),[Quote1]))));
      masRegExp^.Insert(NewStr(Trim(Trim(ExtractWord(2,GetValue(6,x),Separators),SpaceChars),[Quote1])));
      masCatch^.Insert(NewStr(Trim(Trim(ExtractWord(3,GetValue(6,x),Separators),SpaceChars),[Quote1])));
     end;

    l:=GetValueCount(7);
    ps:=nil;
    if (l>0) then for x:=0 to l-1 do
     begin
      ReallocStr(ps,GetValue(7,x));
      with (EchoList^) do if (not Search(ps,i)) then
       begin
        Insert(ps);
        ps:=nil;
       end;
     end;

    l:=GetValueCount(8);
    if (l>0) then for x:=0 to l-1 do
     begin
      alFromAddr^.Insert(NewStr(Trim(Trim(ExtractWord(1,GetValue(8,x),Separators),SpaceChars),[Quote1])));
      alPassword^.Insert(NewStr(Trim(Trim(ExtractWord(2,GetValue(8,x),Separators),SpaceChars),[Quote1])));
      alListName^.Insert(NewStr(Trim(Trim(ExtractWord(3,GetValue(8,x),Separators),SpaceChars),[Quote1])));
      alMsgText^.Insert(NewStr(Trim(Trim(ExtractWord(4,GetValue(8,x),Separators),SpaceChars),[Quote1])));

      lists^.Insert(New(pAvailList,Init(Trim(Trim(ExtractWord(1,GetValue(8,x),Separators),SpaceChars),[Quote1]),
                                        Trim(Trim(ExtractWord(3,GetValue(8,x),Separators),SpaceChars),[Quote1]))));
     end;

    ReallocStr(NetMailFlag,Trim(GetValue(09,0),SpaceChars));

    ReallocStr(NetMailArea,Trim(GetValue(10,0),SpaceChars));

    l:=GetBadLineCount;
    if (l>0) then
     begin
      PrintStr(cr+lf);
      for x:=0 to l-1 do PrintStr('wrong line [#'+NToC(GetBadLine(x))+'] in ['+FileName+']'+cr+lf);
      PrintStr('pause 3 second to check hands...'+cr+lf);
      Delay(3000);
     end;

   end;

  DisposeObj(cfg);
  ReadConfig:=0;
 end;

procedure tRAMa.DoScan;
 var
  i,x: Integer;
  CurMsgNum: Longint;
  base: pAbsBase;
  msg,msg1: pAbsMsg;
  msgFromName,msgFromAddr,msgToName,msgToAddr,msgSubject: String;
  s,sEchoList: String;
  time: Longint;
  ValidSubject, ValidMsg: Boolean;
  massRegExp,massCatch: String;
 begin
{ ᪠஢ 쭮  }
  s:=GetPS(ScanArea);
  PrintStr('scanning netmail base...'+cr+lf);

  base:=OpenOrCreateBase(s,fmRead);
  New(msg,Init);
  New(msg1,Init);

  CurMsgNum:=0;
  while (CurMsgNum<=base^.Count) do
   begin
    while (not base^.ExistMsg(CurMsgNum)) and (CurMsgNum<=base^.Count) do Inc(CurMsgNum);
    msg^.FreeMessage;
    if (base^.LoadMsg(msg^,CurMsgNum)=0) then
     begin
      ValidSubject:=False;
      with (msg^) do
       begin
        msgFromName:=UpStr(GetSourceName);
        msgFromAddr:=TruncateAddr(GetSourceAddress);
        msgToName:=UpStr(GetDestinationName);
        msgToAddr:=TruncateAddr(GetDestinationAddress);
        msgSubject:=UpStr(GetSubject);

        if (
            (FromName^.Search(@msgFromName,i) or (FromName^.Count=0)) and
            (FromAddr^.Search(@msgFromAddr,i) or (FromAddr^.Count=0)) and
            (ToName^.Search(@msgToName,i) or (ToName^.Count=0)) and
            (ToAddr^.Search(@msgToAddr,i) or (ToAddr^.Count=0))
           ) then
         begin

          ValidSubject:=false;
          with (masSubject^) do if (Count>0) then for i:=0 to Count-1 do
          if (pos(UpStr(GetPS(At(i))),UpStr(msgSubject))>0) then
           begin
            ValidSubject:=true;
            break;
           end;

          if (ValidSubject) then
           begin

            with (EchoList^) do if (Count>0) then
             begin
              if (not EchoListLoaded) then for x:=0 to Count-1 do
               begin
                sEchoList:=GetPS(At(x));
                if (not Exist(sEchoList)) then PrintStr('echo list ['+sEchoList+'] not found'+cr+lf)
                else
                 begin
                  if (lists^.LoadEchoList(sEchoList)=0) then
                  PrintStr('echo list ['+sEchoList+'] loaded succesfully!'+cr+lf)
                  else
                  PrintStr('loading of echo list ['+sEchoList+'] failed!'+cr+lf)
                 end;
               end;
              EchoListLoaded:=True;
             end;


            PrintStr('valid msg for availing #'+NToC(CurMsgNum)+DualPoint+Space+
                    GetSourceName+Space+Bracket1+GetSourceAddress+Bracket2+' -> '+
                    GetDestinationName+Space+Bracket1+GetDestinationAddress+Bracket2+cr+lf);
            massRegExp:=GetPS(masRegExp^.At(i));
            massCatch:=GetPS(masCatch^.At(i));
            with (msg^) do
             begin
              MsgBody^.Seek(0);
              repeat
               StreamReadLn(MsgBody^,s);
               if (s='') then continue;
               s:=GrepSub(massRegExp,s,massCatch,false);
               if (Length(s)<3) then continue;
               lists^.AddArea(msgFromAddr,s,'');
              until (MsgBody^.Status<>stOK);
              MsgBody^.Reset;
              ValidMsg:=True;
             end;
           end;
         end;
       end;
      if ((KillScannedMsg=ksmValid) and (ValidMsg)) then base^.DeleteMsg(CurMsgNum);
     end;
    if (KillScannedMsg=ksmYes) then base^.DeleteMsg(CurMsgNum);
    Inc(CurMsgNum);
    if (Abs(time-Timer)>200) or (CurMsgNum=base^.Count) then
     begin
      time:=Timer;
      FastText('searching for next message: '+NToC(CurMsgNum),WhereY,WhereX);
     end;
   end;
  FastText('                                                          ',WhereY,WhereX);
  DisposeObj(msg);
  DisposeObj(msg1);
  DisposeObj(base);

  PrintStr('done!'+cr+lf);
 end;

procedure tRAMa.DoAsk;

 function GetAKA(addr: String): String;
  var
   y: Integer;
  begin
   GetAKA:=GetPS(MainAddr);
   if (ToAddr^.Count>0) then for y:=0 to ToAddr^.Count-1 do
   if (Pos(addr,GetPS(ToAddr^.At(y)))>0) then
    begin
     GetAKA:=GetPS(ToAddr^.At(y));
     exit;
    end;
  end;

 var
  base: pAbsBase;
  msg: pAbsMsg;
  x: Integer;
  LinkN: Longint;
  dt: DateTime;
  addr: String;
 begin
  PrintStr('asking avail lists from uplinks...'+cr+lf);

  New(msg,Init);
  base:=OpenOrCreateBase(GetPS(NetMailArea),stIntOpen or fmReadWrite or fmDenyNone);

  if (alFromAddr^.Count>0) then for x:=0 to alFromAddr^.Count-1 do
   begin
    addr:=GetPS(alFromAddr^.At(x));
    PrintStr('['+addr+']... ');
    with (msg^) do
     begin
      SetSourceAddress(GetAKA(addr));
      SetDestinationAddress(addr);
      SetSourceName(GetPS(MainName));
      SetDestinationName('AreaFix');
      rTime.GetCurrentTime(dt);
      SetDateWritten(dt);
      SetSubject(GetPS(alPassword^.At(x)));
      with (AbsMsgData),(cFlags) do
       begin
        PVT:=True;
        K_S:=True;
        ReallocStr(TearLine,Space+StrPas(ShortAppName)+' v'+StrPas(AppVer));
        TearLined:=True;
       end;
      MsgBody^.Seek(0);
      StreamWriteLn(MsgBody^,GetPS(alMsgText^.At(x)),cr+lf);
      MsgBody^.Truncate;
     end;
    if (base^.SaveMsg(msg^,base^.Count+1)<>0) then PrintStr('cannot save message!'+cr+lf)
    else PrintStr('done!'+cr+lf);
    if (NetMailFlag<>nil) then ZeroFile(GetPS(NetMailFlag));
   end;

  DisposeObj(base);
  DisposeObj(msg);

  PrintStr('done!'+cr+lf);
 end;
var
 RAMa: tRAMa;
begin
 AddExitProc(ErrorExit);
{$IfNDef Debug}
 SetErrorLog(ForceExtension(ParamStr(0),'rte'));
{$EndIf}
 RAMa.Init;
 RAMa.Run;
 RAMa.Done;
end.
